Page tree
Skip to end of metadata
Go to start of metadata

This topic provides information about things you need to check and extra tasks you may need to perform when upgrading your XperienCentral installation to a specific version. The modifications per version are not cumulative which means that you need to apply the changes for all versions between your current version and the one you are upgrading to. For example, if you upgrade from XperienCentral R28 to R32, you need to apply the changes described in this topic for all versions from R29 up to and including R32. For general upgrade information, see Upgrading a Linux Installation or Upgrading a Windows Installation.


See also Changelog per Version for information on issues resolved in each XperienCentral release.


Click an XperienCentral version for specific upgrade information.


XperienCentral R34

Release date: November 18, 2021


Minimum Version Required for Upgrading to XperienCentral R34

Upgrading to XperienCentral R34 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R34.


Check Configuration Files

See Check Configuration Files.

Deprecated Media Repository Method Removed

The following method which was deprecated in 2009 has been removed from nl.gx.webmanager.cms.mediarepository.MediaRepository:

int copyMediaItem(MediaItemVersion mediaItem);


JBoss upgrade

From R34 onwards, JBoss 7.2 EAP is the supported JBoss version. JBoss 7.2 EAP and higher incorporates JDK 11 support. In order to upgrade, download the JBoss 7.2.0 EAP application server from https://developers.redhat.com/products/eap/download. See https://access.redhat.com/articles/2026253 for the supported configurations. In order to run XC on the JBoss application platform, use the standalone.xml and standalone.conf delivered with the XC SDK. For more information, see the updated JBoss information on the Linux Server Installation page.




XperienCentral R33.1

Release date: September 27, 2021


Minimum Version Required for Upgrading to XperienCentral R33.1

Upgrading to XperienCentral R33.1 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R33.1.


Check Configuration Files

See Check Configuration Files.

CSRF Approved URL Setting

A new CSRF setting has been added that allows you to approve URLs and bypass the CSRF checks. See the setting csrf_ignore_url_paths_regex in the application_settings section of the General tab of the Setup Tool.

Exempting URLs from the CSRF checks weakens the security of your channel(s), therefore you should exercise caution with this setting.

Minimum Java Version

Beginning in R33.1, the minimum Java version required to run XperienCentral is Java 11. The maximum Java version supported is Java 13. This is also required for the XperienCentral add-ons:

  • Content API
  • Monitoring Framework
  • Headless Integration
  • Modular Content







XperienCentral R33

Release date: July 30, 2021


Minimum Version Required for Upgrading to XperienCentral R33

Upgrading to XperienCentral R33 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R33.


Check Configuration Files

See Check Configuration Files.

Google Sitemap Automatic Upload

In XperienCentral R33, a new setting for controlling whether XperienCentral automatically uploads generated sitemaps to Google has been introduced. The setting google_sitemap_automatic_upload can be found in the application_settings section of the General tab of the Setup Tool. When enabled, if a Google sitemap is generated, it is automatically uploaded according to the schedule configured in the setting google_sitemap_generator_schedule. When disabled, the latest generated sitemap is not uploaded.

Because it is disabled by default, when upgrading from R32, the option must be enabled manually if XperienCentral should continue to automatically submit the sitemap to Google.

New Channel for the Interactive Forms Panel

Beginning in XperienCentral version R33, the Interactive Forms panel uses the "iafpanel" channel to render forms. This mechanism makes it possible to decouple the IAF visual representations from the website presentation. New presentations should use it for all standard fragment types unless the representation inside the IAF panel must resemble the website's presentation. When upgrading, there are 3 possible options for handling this situation:

  1. Add "iafpanel" (without quotes) to the channels_using_fallback setting in the application_settings section of the General tab of the Setup Tool. This will make all presentations without an explicit "iafpanel" channel declaration behave as described in option 3 below. This is the quickest fix. The notes in option 3 be;pw also apply to this option.
  2. Add the "iafpanel" channel to all custom formStep, FormSectionVersion and form fragment presentation descriptors. This will deliver the best Edit side presentation and will prevent the custom presentations from being cluttered with Edit-side logic. For a text input fragment, the channel declaration looks like this:

    <channel>
       <name>iafpanel</name>
       <presentation>FormFragmentTextInput</presentation> <!-- Name of IAF's own presentation -->
    </channel>


    As a result, any code in the presentation JSPs that is specific to the preview mode can be removed.

  3. Add the "iafpanel" channel to all custom formStep, FormSectionVersion and form fragment presentation descriptors and have it refer to itself. The Interactive Forms panel will then continue to use the custom presentations, making it possible to have the same HTML output in the panel as on the website.

    Notes

    • Option 1 has the same effect as Option 3 but it is easier to implement. The disadvantage of using Option 1 is that it might not be obvious that an "iafpanel" channel that you want to point to the IAF's own presentation (Option 2) is missing from a presentation descriptor.
    • The IAF panel presentation(s) may look different than the pre-R33 version(s) because of changes to the CSS.
    • When the fragmentDiv tag is overruled in a custom presentation plugin, the new logic for adding the data-jcr-uuid attribute in Edit mode that has been added to IAF's fragmentDiv tag must be copied from it.
    • Option 2 or 3 can be used separately for each presentation.

CSRF Settings

To better protect websites hosted by XperienCentral against CSRF attacks, a new mechanism has been introduced that uses a CSRF token that is stored in a cookie, and an SHA-256 hash of this token plus a random 16 character long nonce, postfixed with the used nonce, must be included in all non-GET requests to the server as a header or form field. This change could affect custom functionality in the following ways:

  • If a custom version of the Interactive Form file formvalidationbindings.js is used, it must be updated with the anti-CSRF changes which can be found by searching for "csrf" in the upgraded formvalidationbindings.js.
  • If the Interactive Form formsHeadTag presentation is not called from a custom presentation plugin, then the page presentations of this plugin must include the /<context path>/js/form/csrfprotection.js script.
  • If XHR form posts are performed in custom panels, elements or widgets, the X-CSRF-Token header must be added to these posts.
  • The secure_rest_against_csrf configuration setting and the mandatory use of the X-Session-Verify header when it is enabled are now only relevant for GET requests to XperienCentral's REST API. All other types of requests to the REST API are now always checked, irrespective of the secure_rest_against_csrf configuration setting, and they must contain the X-CSRF-Token header. See the application_settings section of the General tab of the Setup Tool for complete information on the secure_rest_against_csrf setting.
  • If custom voting presentations are used, the X-CSRF-Token must be added to the form posts they execute. See voting.jspf in the Community Edition presentation for an example.
  • External requests to /services/oembed must add a X-CSRF-Token header to the request. It can be retrieved from the X-CSRF-Token response header when the steps on Security Guidelines for Developers have been followed.
  • It is not possible to submit forms to XperienCentral from other domains, even when that domain is another channel of the same XperienCentral installation, because browsers do not allow reading cookies from another domain.

See also Security Guidelines for Developers for more information.

formvalidationbindings.js

The following changes have been made to the formvalidationbindngs.js file:

  • A new initCSFW function has been added that is called in the $(document).ready for all forms and from the IAF_FormLoaded event listener.
  • initCSFW calls the new loadScript function which adds a script tag to load the client-side framework.
  • The IAF_ShowFormFragment and IAF_HideFormFragment event listeners have been updated to prevent event propagation.
  • The IAF_SubmitForm event listener has been updated to add the anti-CSRF header when submitting the form using Ajax and to support form fields that have "submit" as their identifier.
  • The IAF_AjaxShowFormStep event listener now checks whether the response contains the X-CSRF-Token header. If it does, then it creates a hidden input with its value. This is done to support IAF forms on external domains.
  • The formObj.submit function defined in the init function has been updated to add the anti-CSRF input field when submitting the form.
  • A new showGeneralErrorMessage function has been defined that shows a general error message at the top of a form when a communication error occurs.

Interactive Forms Upload Element

The Upload element in Interactive Forms has been modified to allow multiple file uploads. You can also set a minimum and maximum number of allowed files in an Upload element. See Creating Forms for complete information.

Modular Content Tag Property change (v2.0.13)

Properties of type tag are now referenced using an ID instead of by name. For example, suppose you have the following tag property:

TemplateProperty tagProperty = modularVersion.getModularTemplateInstance().getPropertyByIdentifier("mypropertyoftypetag");

Previously, the tag name would be retrieved using tagProperty.getStringValue(). Now the (Siteworks) ID of the property must first be retrieved using getIntegerValue() and, given that, the correspronding MediaTerm can be retrieved using getWrapper. For example:

Previously in Java

TemplateProperty property = modularVersion.getModularTemplateInstance().getPropertyByIdentifier("mypropertyoftypetag");
String tagName = property.getStringValue();

Now in Java

TemplateProperty property = modularVersion.getModularTemplateInstance().getPropertyByIdentifier("mypropertyoftypetag");
Long tagId = property.getIntegerValue();
Session session = getSessionManager().getActiveSession();
MediaTerm categoryTag = (MediaTerm) session.getWrapper(tagId.intValue(), MediaTerm.class);
String tagName = categoryTag.getName();

Previously in JSP Code

<c:set var="mediaItem" value="${presentationcontext.mediaItem}" />
<c:set var="currentMV" value="${mediaItem.current}" />
<c:if test="${wmfn:instanceOf(currentMV, 'nl.gx.product.wmamodularcontent.api.ModularMediaItemArticleVersion')}">
   <c:set var="mti" value="${current.modularTemplateInstance}" />
   <c:set var="supportedContenttype" value="${mti.type.identifier eq 'examplecontenttype'}" />
</c:if>
<c:choose>
   <c:when test="${supportedContenttype && not empty mti.getPropertyByIdentifier('mypropertyoftypetag').getStringValue()}">
      <c:set var="tagName" value="${mti.getPropertyByIdentifier('mypropertyoftypetag').getStringValue()}" />
   </c:when>
   ....
</c:choose>

Now in JSP Code

<c:set var="mediaItem" value="${presentationcontext.mediaItem}" />
<c:set var="currentMV" value="${mediaItem.current}" />
<c:if test="${wmfn:instanceOf(currentMV, 'nl.gx.product.wmamodularcontent.api.ModularMediaItemArticleVersion')}">
   <c:set var="mti" value="${current.modularTemplateInstance}" />
   <c:set var="supportedContenttype" value="${mti.type.identifier eq 'examplecontenttype'}" />
</c:if>
<c:choose>
   <c:when test="${supportedContenttype && not empty mti.getPropertyByIdentifier('mypropertyoftypetag').getIntegerValue()}">
      <c:set var="tagId" value="${mti.getPropertyByIdentifier('mypropertyoftypetag').getIntegerValue()}" />
      <wm:object var="tagObject" objectId="${tagId}" objectType="nl.gx.webmanager.cms.mediarepository.mediaTerm" hideError="true" />
      <c:set var="tagName" value="${tagObject.name}" />
   </c:when>
   ....
</c:choose>

Interactive Forms Deprecated Methods

In XperienCentral versions R33 and higher, the following form methods have been deprecated.

FormScope

The following method has been deprecated:


void setUploadFragmentValue(String fragment, UploadedFile file);


use the following method instead:


void setUploadFragmentValues(String fragment, List<UploadedFile> files);


FormValuesMap

The following method has been deprecated:


public UploadedFile getUploadedFile(String key)


use the following method instead:


public List<UploadedFile> getUploadedFiles(String key)


UploadFragmentScope

All methods have been deprecated. Use the following method instead:


List<Object> files = scope.getValues();
if (files != null) {
   for (Object fileObj : files) {
      if (fileObj instanceof UploadedFile) {
         UploadedFile file = (UploadedFile) fileObj;
      
         // Now read the attributes
         File file = file.getFile();
         long size = file.getSize();
         String contentType = file.getContentType();
         ...
      }
   }
}   










XperienCentral R32

Release date: May 12, 2021


Minimum Version Required for Upgrading to XperienCentral R32

Upgrading to XperienCentral R32 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R32.


Check Configuration Files

See Check Configuration Files.

Rebuild the Content Index

Due to a change in the Search functionality, you must rebuild the content index. To do so, manually remove the <webmanager-root>/work/contentindex directory after the upgrade and allow it to be regenerated after restarting XperienCentral. Selecting contentindex_queue_empty_reindex in the Setup Tool is not sufficient.

Check Google Sitemap Generator Schedule

In R32, XperienCentral generates and uploads a Google Sitemap by default once per day. If you do not want to generate a sitemap, clear the field google_sitemap_generator_schedule in the application_settings section on the General tab of the Setup Tool in each environment where you want to disable this functionality. You can also change the schedule to something else if desired.

Changes to the XperienCentral API

Removed Methods

The following deprecated methods have been removed in R32:

  • MediaRepository#updateMediaItem
  • PageManagementService#addLeadText(PageVersion pageversion)
  • PageManagementService#addLeadText(PageModel pageModel)

Added Methods

The methods PageVersion#getLead() and PageVersion#setLead, which were deprecated in XperienCentral version 10.13.0, have been undeprecated in R32. In version R32, page versions and media item versions now have both a Lead Text (#getLead) and a Meta Description (#getMetaDescription) which can be used separately. The purpose of the Meta Description field is to fill the head field in the HTML used by search engines. For example

<meta name="description" content="value of the meta description field" />

The purpose of the Lead field is to provide a short summary of the content item's content and can be used, for example, as a summary in a search function or in a Content Overview. One important difference is that, as designed, the Meta Description field is not meant to be visible to end users while the Lead Text is.

The following methods have been moved from MediaItemVersion to ContentItemVersion in order to make lead text and lead images also available to pages in the API:

  • String getLead();
  • void setLead(String leadText);
  • Image getLeadImage();
  • Image getLeadImageThumbnail();
  • Image getAttachedLeadImage();
  • void setAttachedLeadImage(FileResource leadImage);
  • MediaItem getLeadImageMediaItem();
  • void setLeadImageMediaItem(final MediaItem mediaItem);

Furthermore, the following methods have been added to ContentItemVersion

  • boolean getHasLead();
  • void removeAttachedLeadImage();
  • void setAttachedLeadImageFocusPoint(int x, int y);








XperienCentral R31

Release date: March 4, 2021


Minimum Version Required for Upgrading to XperienCentral R31

Upgrading to XperienCentral R31 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R31.


Check Configuration Files

See Check Configuration Files.

Default Content Language

  • A change has been made to how the default content language is determined. Beginning in XperienCentral R31, the default language is the language that has the rank of "1" in the list of supported languages in the Language Labels panel.
  • In XperienCentral versions R31 and higher, the default content language is set to Dutch in a clean installation.
  • After upgrading to XperienCentral R31, ensure that the default content language for your channel(s) in the edit environment is correct. See Setting the Default Content Language for XperienCentral.
  • In some cases, the new default language setting can have an effect on the default language of the home page on the website frontend. After upgrading, check the language used by your home page on the frontend by default.
  • Due to issue GXWM-37982,  it might not be possible to set the default content language in the Language Labels panel in a multi-channel (multi-website) installation. If you run into this problem, the order can be changed using the JCR Browser. Follow these steps:

    1. Look up the channel node using "//element(*)[@wm:id='26098']". Change "26098" to the ID of the channel for which you want to modify the default content language.
    2. Click the wo_wmregistry child node in the results.
    3. Edit the wo:language property.
    4. Reorder the UUIDs as desired and then click [Update].

New WYSIWYG Editor in Interactive Forms

In XperienCentral R31, a new WYSIWYG editor has been introduced in Interactive Forms. It generates HTML in a slightly different way than the old editor. The changes introduced by the new WYSIWYG editor are:

  • Heading tags (<h1>-<h6>) and <p> tags are no longer wrapped in a <div>.
  • <b> tags are replaced by <strong> tags.
  • <i> tags are replaced by <em> tags.
  • Indendation in lists is now rendered using nested lists instead of <blockquote/> elements.

After ugrading to XperienCentral R31, HTML already stored in existing form elements remains unchanged. All new HTML produced after the upgrade will be generated in the new way. If you edit an existing WYSIWYG form element, it will be upgraded after saving. In some cases, extra whitespace may be introduced between elements.

GX Software recommends that you check new or modified WYSIWYG form elements after upgrading to R31 in order to determine whether you need to tweak your CSS to accommodate the behavior of the new WYSIWYG editor.

Connector Definition for AJP/1.3 Connections

In Tomcat versions 8.5.51, 9.0.31 and later, the connector definition in the server.xml file must contain the attribute secretRequired="false" for AJP/1.3 connections. Please check your server.xml file and ensure that the connector definition contains this attribute. For example:

<Connector port="8009" enableLookups="false" redirectPort="8443" debug="1" protocol="AJP/1.3" secretRequired="false" URIEncoding="UTF-8" connectionTimeout="600000" />

getPersonalizationXMLData

The getPersonalizationXMLData method in the PersonalizationXMLDataProvider API has been changed from

String getPersonalizationXMLData(HttpServletRequest request);

to

String getPersonalizationXMLData(HttpServletRequest request, HttpServletResponse response);

If you use this method, you must refactor your code to cope with the modification.

getMediaItemVersions

In version R31 of XperienCentral, the tag getMediaItemVersions has been added and the tag getMediaItems has been deprecated. getMediaItemVersions was added to support media item language versions. If you currently use the getMediaItems tag in your code, you need to refactor it to use getMediaItemVersions. Proceed as follows:

Replace all instances of the getMediaItems tag:


<wm:getmediaitems var="mediaItems"/>

<c:forEach var="mediaItem" items="${mediaItems}">  
   <c:set var="mediaItemVersion" value="${mediaItem}"/>
   <c:if test="${not empty mediaItemVersion}">
      //attributes
   </c:if>
</c:forEach>


to getMediaItemVersions. For example:


<wm:getmediaitemversions var="mediaItemVersions"/>

<c:forEach var="mediaItemVersion" items="${mediaItemVersions}"> 
   //attributes
</c:forEach>


See getMediaItemVersions and the Javadoc for getMediaItemVersions for more information.

Delete Cache Before to Logging in to an XperienCentral R31 Installation Running Locally

Due to a change to internal JavaScript files in this release, GX Software strongly recommends that you delete your browser cache if you run a local installation of XperienCentral R31 after upgrading but before logging in for the first time. This does not apply to XperienCentral running on an Apache web server.

GX WebManager JUnit Wrapper Bundle

Beginning in XperienCentral version R31, the JUnit wrapper bundle is no longer deployed to XperienCentral by default. It is possible that plugins (including any reusables) built against older versions of XperienCentral still have an indirect dependency on this plugin which results in those dependent plugins not starting when XperienCentral is started.

There are two ways to fix this issue:

  • Rebuild custom plugin(s) against XperienCentral version R31
  • For resuables for which no R31 version or later version is available, you can manually deploy the webmanager-junit-bundle which can be found in the SDK under /maven2-repository/nl/gx/webmanager/testbundles/webmanager-junit-bundle.


XperienCentral R30.1

Release date: December 10, 2020


Minimum Version Required for Upgrading to XperienCentral R30.1

Upgrading to XperienCentral R30.1 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R30.1.


Check Configuration Files

See Check Configuration Files.

XSS Features

  • In XperienCentral R29.3, extended protections against XSS vulnerabilities have been introduced. A number of input fields in XperienCentral are now more rigorously validated against known XSS attacks. If the value of an input field is forbidden, the old value of the input field will remain unchanged and the upgrade is ignored. You can of course still allow this sort of input by adding it to a trusted list, however GX Software strongly recommends against doing so.
  • When input fields contain unsafe input before the upgrade, the content of these fields remains unchanged after the upgrade. If the content of one of these input fields is subsequently changed to other content considered unsafe, the updated content is ignored and the old (unsafe) content will remain.

External Application Support

  • The External Applications module has been removed from XperienCentral in version R29.3. Because that also removes the xslStyleSheetApplicationInclude.xml presentation, all references to this presentation should be manually removed from your project. For example, in the XperienCentral Community Edition plugin's xslStyleSheet.jspf file, the following line is removed:

     <wm:render presentationName="xslStyleSheetApplicationInclude" />

Uploaded File Handling

  • A new Apache rule should be added when upgrading to R30.1 in order to prevent uploaded files from being be opened inside the browser. Add the following rule to one of the configuration files included in the Apache httpd.conf file: 

         <Location ~ "(/upload|/upload_mm)">
        Header set Content-Disposition "attachment"
     </Location>

See also Linux Server Installation.

xss_allowlist_siteworks_expressions

The setting xss_allowlist_siteworks_expressions was added in this version in the application_settings section of the General tab of the Setup Tool. To avoid generating WARNING messages in the log, change the value of this setting to "wm_language_search.help" (without the quotes).




XperienCentral R29.3

Release date: December 2, 2020


Minimum Version Required for Upgrading to XperienCentral R29.3

Upgrading to XperienCentral R29.3 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R29.3.


Check Configuration Files

See Check Configuration Files.

XSS Features

  • In XperienCentral R29.3, extended protections against XSS vulnerabilities have been introduced. A number of input fields in XperienCentral are now more rigorously validated against known XSS attacks. If the value of an input field is forbidden, the old value of the input field will remain unchanged and the upgrade is ignored. You can of course still allow this sort of input by adding it to a trusted list, however GX Software strongly recommends against doing so.
  • When input fields contain unsafe input before the upgrade, the content of these fields remains unchanged after the upgrade. If the content of one of these input fields is subsequently changed to other content considered unsafe, the updated content is ignored and the old (unsafe) content will remain.

External Application Support

  • The External Applications module has been removed from XperienCentral in version R29.3. Because that also removes the xslStyleSheetApplicationInclude.xml presentation, all references to this presentation should be manually removed from your project. For example, in the XperienCentral Community Edition plugin's xslStyleSheet.jspf file, the following line is removed:

     <wm:render presentationName="xslStyleSheetApplicationInclude" />

Uploaded File Handling

  • A new Apache rule should be added when upgrading to R29.3 in order to prevent uploaded files from being be opened inside the browser. Add the following rule to one of the configuration files included in the Apache httpd.conf file: 

         <Location ~ "(/upload|/upload_mm)">
        Header set Content-Disposition "attachment"
     </Location>

See also Linux Server Installation.

xss_allowlist_siteworks_expressions

The setting xss_allowlist_siteworks_expressions was added in this version in the application_settings section of the General tab of the Setup Tool. To avoid generating WARNING messages in the log, change the value of this setting to "wm_language_search.help" (without the quotes).







XperienCentral R30

Release date: October 28, 2020


Minimum Version Required for Upgrading to XperienCentral R30

Upgrading to XperienCentral R30 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R30.


Check Configuration Files

See Check Configuration Files.

 








XperienCentral R29.2

Release date: October 8, 2020


Minimum Version Required for Upgrading to XperienCentral R29.2

Upgrading to XperienCentral R29.2 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R29.2.


Check Configuration Files

See Check Configuration Files.

 








XperienCentral R29.1


Due to a known issue which has been solved, GX Software strongly recommends that you do not install or upgrade to XperienCentral version R29.1.


Release date: September 7, 2020


Minimum Version Required for Upgrading to XperienCentral R29.1

Upgrading to XperienCentral R29.1 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R29.1.

Check Configuration Files

See Check Configuration Files.

Changes to the Interactive Forms Date Validator

The date validator in Interactive Forms now only accepts the yyyy-mm-dd date format instead of dd-mm-yyyy. As a result, the formFragmentDateInput presentation in wmpformpresentation now generates a yyyy-mm-dd formatted date for the backend instead of dd-mm-yyyy. If you have a custom implementation of formFragmentDateInput that returns dates in the dd-mm-yyyy format, you need to modify it to return yyyy-mm-dd instead.

Additionally, you need to check any post-processing code that further handles dates submitted in an Interactive Form. For example, if the date submitted in the form is used in an email handler or stored in a database, you need to evaluate how this change affects any further processing you do on data received in forms.

 








XperienCentral R29


Due to a known issue which has been solved, GX Software strongly recommends that you do not install or upgrade to XperienCentral version R29.


Release date: July 21, 2020


Minimum Version Required for Upgrading to XperienCentral R29

Upgrading to XperienCentral R29 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R29.

Check Configuration Files

See Check Configuration Files.

New Method for Retrieving Media Items in Content Overviews

In this release, the Dynamic Content Overview now supports an explicit fallback language selection. For this implementation, the API of MediaCollectionElement (inherited by MediaCollectionOverviewElement) has been extended with the new method getMediaItemVersions() which replaces the method getMediaItems().

getMediaItemVersions() returns the correct media item version depending on the fallback language selected in the Dynamic Content Overview tab. In order to render the correct media item versions in the mediaCollectionElement on the frontend, the presentation JSP of the mediaCollectionElement must now use the new API method getMediaItemVersions().

For example, in webmanager-wcbs/webmanager-cestyle-wcb/src/main/resources/presentationtype/jsp/element/mediaCollectionElement.jspf, the code


<c:forEach var="mediaItem" items="${mediaCollectionElement.mediaItems}">
<c:set var="mediaItemVersion" value="${mediaItem.current}" />

must be replaced by:

<c:forEach var="mediaItemVersion" items="${mediaCollectionElement.mediaItemVersions}">
<c:set var="mediaItem" value="${mediaItemVersion.contentItem}" />

Beginning in version R29, SEO URLs are now available for downloads. If download elements are linked to downloads in the Content Repository, a small change is required to use these new SEO URLs. The change must be applied to each presentation of a download element (any presentation with scope DownloadElement).


For downloads whereby a file is uploaded directly in the Download content element, no change is required and you should continue to use your current implementation.


Beginning in R29, use the wm:link tag for downloads just as you would for any other media item in the Content Repository. For example:


<%-- Generate the link using th wm:link tag --%>
<wm:link var="downloadLink" reference="${mediaItemVersion.targetPage}" contentid="${mediaItem.id}" linkText="${mediaItemVersion.title}" /> 

<%-- HTML escape and render the link --%>
<h2 class="normal"><a href="${wmfn:escapeToHTMLAttribute(downloadLink.url)}">${wmfn:escapeToHTML(downloadElement.title)}</a></h2> 

New Security Protocol Setting for Frontend Servers

In XperienCentral R29, a new preview functionality was introduced. Among other things, this feature enables visitors who do not have permission to log in to the XperienCentral backend to nevertheless preview unpublished content. For this reason, the new setting frontend_use_https has been introduced. This setting can be configured for each website individually. frontend_use_https is disabled by default which means that preview links will be generated using the HTTP protocol if you do not enable it.


 

 








XperienCentral R28

Release date: May 13, 2020


Minimum Version Required for Upgrading to XperienCentral R28

Upgrading to XperienCentral R28 requires a minimum version of R26. If you are upgrading from XperienCentral R25 or lower, you must first upgrade to R26 and then upgrade to XperienCentral R28.

Check Configuration Files

See Check Configuration Files.

Performance Dashboard is Removed

The Performance Dashboard has been removed from XperienCentral in R28. Use the Monitoring Dashboard to view statistics and metrics related to your XperienCentral deployment. See also Administrative Pages.

While the upgrade scripts for XperienCentral should in principle remove all components related to the Performance Dashboard, in some circumstances it may not, therefore you need to manually remove any remnants. Follow these steps:

  1. Navigate to Configuration > Plugins.
  2. Locate "GX WebManager - Performance Dashboard" in the list and select it.
  3. Click [Uninstall].
  4. Click [Yes] when you are prompted to remove all data related to this plugin (purge).
  5. Repeat the steps above for the "GX WebManager - SystemHealthIndicator tracker" plugin.

See also Plugins Management Console.

Code Changes

The nestedPath attribute has been removed from fragmentValue.tag in the wmpformelement plugin. It has been replaced by the attribute formFragment. The value of this attribute contains an object with a nestedPath property. Wherever you use the <forms:fragmentValue> tag, you have to replace the nestedPath property. For example:

<forms:fragmentValue nestedPath="${formFragment.nestedPath}" />

must be changed to:

<forms:fragmentValue formFragment="${formFragment}" />

JCR Index

Beginning in R28, XperienCentral uses an XperienCentral-optimized indexing solution to support queries on frontend nodes instead of the Apache Jackrabbit JCR. This solution generally improves performance and drastically reduces the amount of time it takes to bring a new frontend node online in cloud deployments when traffic demands increase. The new indexing solution will always be used in XperienCentral even if the old JCR index is not disabled. The old JCR index should be disabled on production environments if possible.

See also the new JCR Index Settings that have been added to the Setup Tool.

JCR Query Replacement

If you use custom JCR queries in your deployment, they should be replaced in order to use the new API. The following shows a typical query replacement:

Queries similar to this:



With the JCR index

String xPathQuery = "//element(*, wo:personalization_category)[@wo:items = '" + getUUID() + "']";
final QueryManager queryManager = wmSession.getJcrSession().getWorkspace().getQueryManager();
final Query elementsQuery = queryManager.createQuery(xPathQuery, Query.XPATH);
NodeIterator nodes = elementsQuery.execute().getNodes();

 

should be changed to something like this:

 
Without the JCR index

NodeIterator nodes = getJcrIndexQueryManager().getNodes(wmSession.getJcrSession(), "wo:personalization_category", Collections.singletonMap("wo:items", getUUID()));

 

Disabling the Built-in Apache Jackrabbit JCR Index

To disable the old Apache Jackrabbit JCR index, follow these steps:

  1. Remove both occurrences of: <SearchIndex>...</SearchIndex> in <wm-root>/work/jcr/repository.xml.
  2. Remove the directory <wm-root>/work/jcr/repository.

Content API User Credentials

In the Connector API, there are two locations in Configuration > Import/Export Configuration where user credentials define which user account executes import/export jobs: one on the Configuration tab and one on the Job tab. The Job tab previously contained the fields "Username", "Password" and "Use application key". The Cofiguration tab contained the same fields with an additional "Website" field. These fields have been replaced by a single "User" drop-down list. In R28 a new System user option has been introduced in the User Authorization panel. Only user accounts designated as system users can be authorized to execute automated export/import jobs.

Re-add Users as System Users

After upgrading to R28, the existing username(s) will still be used by the Connector API. As soon as you open either of the panels, however, the user(s) might not be selectable anymore and if you re-save the configuration, the jobs might stop running. This is the intended behavior. The solution is to navigate to the Authorization panel, designate new system users and then designate them as the user accounts that run jobs on the Configuration and Job tabs in Import/Export Configuration.






XperienCentral R27

Release date: March 26, 2020

Check Configuration Files

See Check Configuration Files.

Language Version Support for Media Items

Beginning in XperienCentral 10.27.0, each version of a media item has a specific language defined for it. During the upgrade R27 or higher, each media item is assigned the default editing language of the home page. A consequence of this is that media items might not be shown any longer if its language differs from that of the page on which it should be shown. This is also the case for (lead) images stored in the Content Repository. This can be solved in many cases by defining a fallback language for the languages on your channel. If the fallback language for Dutch is set to English, for example, and there is no Dutch media item to be shown on a Dutch page, then the English version will be shown. This is the case for all kinds of media items, images as well as articles, for example.

Check the following to ensure that media items in your channel(s) are handled appropriately:

  • The "Language" setting (default editing language) for the home page: Properties widget > General > Other > Language.
  • Enable/disable fallback langauge(s) setting: Channel Configuration > General > Options > "Use another language if language is not available".
  • The fallback language to use for a language: Language Labels.

Modify your Solr Configuration

In this version of XperienCentral, the Lucene version has been upgraded to version 6.6.6, therefore you must make the following changes to solrconfig.xml:

Change the declaration

<luceneMatchVersion>5.4.1</luceneMatchVersion>

to

<luceneMatchVersion>6.6.61</luceneMatchVersion>

and add the following declaration to the <config></config> section:

<schemaFactory class="ManagedIndexSchemaFactory">
   <bool name="mutable">false</bool>
</schemaFactory>


Deprecated Method

The following method has been deprecated in the XperienCentral API in this release:

  • MediaRepositoryManagementService.createMediaItemVersion (MediaItem,MediaItemVersion) — Use createMediaItemVersion(MediaItemVersion) instead.

Removed Methods/Interfaces

The following methods and interfaces have been removed from the XperienCentral API in this release:

  • MediaRepository.createContent — Use MediaRepositoryManagementService.createMediaItem(Website, String) instead.
  • MediaItemDownloadVersion.getPersonalization() — Use getPersonalizationItem() instead.
  • PageVersion.getPersonalization() — Use getPersonalizationItem() instead.
  • Element.getPersonalization() — Use getPersonalizationItem() instead.
  • Element.setPersonalization() — Use setPersonalizationItem() instead.
  • MediaItemDownloadVersion.setPersonalization() — Use setPersonalizationItem() instead.
  • Website.getPersonalizations() — Use getPersonalizationItems() instead.
  • Utilities.checkPersonalizations() — Use checkPersonalizationItems() instead.
  • DirectoryElement
  • FileNode
  • PollElement

  • PollItem

  • WhoIsWhoElement

Update your Presentation JSPs

You need to update your presentation JSPs if they use the following methods:

  • PageVersion.getPersonalization()
  • Element.getPersonalization()
  • MediaItemDownloadVersion.getPersonalization()

Perform a global search in your presentation JSPs for the string ".personalization" to ensure that you catch all instances.



XperienCentral R26.1

Release date: January 21, 2020

Check Configuration Files

See Check Configuration Files.

Solr Search

The search functionality has been upgraded to Solr 6 in this version of XperienCentral. After upgrading, perform the following steps in order to prepare your deployment for Solr 6:

  1. Stop Tomcat if it is running.
  2. Remove the directory <webmanager-root>/work/searchengine.
  3. If you have a custom solrconfig.xml, you need to modify it — open it in a text editor.
  4. Remove the following declaration:

    <requestHandler name="/admin/" class="org.apache.solr.handler.admin.AdminHandlers" />

  5. Save your custom solrconfig.xml.
  6. Start Tomcat.
  7. Log in to XperienCentral.

Realtime indexing

If you use real-time indexing (the XperienCentral Realtime Indexing reusable):

  1. Navigate to Configuration > Realtime Indexing.
  2. Select the "Indexing" tab.
  3. Select all the websites that you want to index in the top part of the panel.
  4. Click [Index selected items].

No realtime indexing

  1. Open the Setup Tool.
  2. Select the Search Tools tab.
  3. Click [Index] in the "INDEX URL" section.



XperienCentral R26

Release date: December 11, 2019

  • The behavior of the setting http_use_proxy has changed. Beginning in XperienCentral R26, proxy system properties set outside of XperienCentral are no longer overwritten when this setting is clear (false). See the "application_settings" section of the General tab in the Setup Tool.
  • Support for Flash films has been removed from XperienCentral in R26. All Flash content elements in your content items will be removed when you upgrade to this version of XperienCentral. The Flash files themselves will still be present in the Content Repository but they cannot be accessed.




XperienCentral R24.2

Release date: November 19, 2019

Support for Flash films has been removed from XperienCentral in R24.2. All Flash content elements in your content items will be removed when you upgrade to this version of XperienCentral. The Flash files themselves will still be present in the Content Repository but they cannot be accessed.


Upgrading from R24.2 to R25.0 is not supported.




XperienCentral R25

Release date: October 9, 2019

Several changes/additions have been made to XperienCentral API interfaces. If you extend any of these interfaces and have developed your own implementations for them, you may experience failing project builds with XperienCentral R25. Some modifications may have to be implemented for newly added methods. If your custom code extends any of the interfaces listed below, you will have to add new methods to your implementations. See the XperienCentral Javadoc for complete information. The modified interfaces are:

  • Presentable
  • TableElement
  • DownloadElement
  • ImageElement
  • MediaCollectionOverviewElement
  • ListElement
  • PageCollectionElement
  • QueryElement
  • RssFeedElement
  • SearchElement
  • RichTextElement

Upgrading from R24.2 to R25.0 is not supported.





XperienCentral R24.1

Release date: July 2, 2019

Startup performance has been significantly improved. Bundles are now updated only if they have been modified. In XperienCentral R24.0 and earlier, all bundles were updated at startup, regardless of whether they had been modified. Beginning in XperienCentral R24.1, bundles are only updated if:

  • The version is newer than the one installed.
  • The last modified date of the bundle's Bnd-LastModified header in the META-INF/MANIFEST.MF (if present) is more recent than the last modified date of the installed bundle.
  • The Bundle-Date in the META-INF/MANIFEST.MF is more recent than the last modified date of the installed bundle.

This means that if you update anything in the bundle but not these two properties, the bundle will not be updated. This applies to updating bundles in the WAR file, bundles copied to the work/deploy directory and to bundles manually uploaded from the Plugins panel.






XperienCentral R24

Release date: June 5, 2019

Access to the Administrative Pages is no longer restricted to users who have the basic HTTP credentials for a page. When a user has the permission "Access debugging tools" in the category "System utilities" and the user is logged in, they no longer need to provide additional credentials in order to access the Administrative Pages. As a consequence however, the credentials dialog no longer appears automatically when access is requested. If the user is not logged in, they will need to first navigate to:

<xperiencentral-server>/web/admin/login

where <xperiencentral-server> is the name of the server on which XperienCentral is running,

Modular Content Plugin

  • Uninstall the Plugin "Add-on - Modular Content" from the Plugins panel before installing the updated deploy. After installing the updated deploy, install the bundle "wmamodularcontent-1.1.0.jar" from the Plugins panel. This plugin can be found in the edition-bundles directory of the XperienCentral SDK.

Monitoring Framework Plugin

  • After every change in a schedule of one or more indicator sets, the "Add-on - XC Monitoring Framework API" plugin has to be restarted via the Plugins panel to ensure the updated schedule is taken into account.






XperienCentral R23

Release date: March 8, 2019

  • Beginning with this XperienCentral release, the version number is no longer prefixed with "10." XperienCentral releases are now designated using "R" together with the major/minor version number (R23, R24, R24.1, and so forth).
  • In this release XperienCentral has been split into two modes: the original XperienCentral is named XperienCentral Traditional and a new mode named XperienCentral Headless. When upgrading to this release or newer, a new license is required. The new license has a new XperienceCentral version node to determine which version of XperienCentral has to be loaded and it makes some changes in the licensed components.
  • The Community Edition plugin is licensed beginning in XperienCentral R23. Customers that depend on presentations from this bundle should do one of the following:
    • Add the presentations from the CE plugin that are depended on to their own presentation plugin;
    • Request that the CE style presentation plugin be added to their configuration license file (configuration.xml).




XperienCentral 10.22.1

Release date: January 9, 2019

  • In XperienCentral 10.22.1 the jQuery library has been upgraded to version 1.12.4. Where JQuery code is used in a widget, design templates or other custom code, the new version might cause compatibility problems. Please check for compatibility problems in your jQuery code when upgrading to XperienCentral 10.22.1 or higher.
  • Support for Tomcat 8.5.35 has been added. To use this version, you require a different database driver when using MSSQL as your database, See the XperienCentral Installation Guides for more information. Changes to the server.xml and the database drivers in the Tomcat lib directory are required.
  • The bundles "GX Webmanager - DatasourceProvider (MS-SQL JDBC 1.1)" and "GX Webmanager - DatasourceProvider (jTDS 1.2.3)" are no longer supported and should be removed after upgrading.
  • Support for Apache Maven 3.6.0 has been added.






 XperienCentral 10.22.0

See also the XperienCentral 10.22 Changelog for information on the issues that have been fixed and other product improvements.

DependencyManager

In XperienCentral 10.22.0, the DependencyManager implementation has been changed. This has an impact for plugins that use the DependencyManager object in their Activator class with package name org.apache.felix.dependencymanager. In XperienCentral versions prior to 10.22.0, the library DependencyManager version 3.0.0 and DependencyManager Compat 3.0.0 were available. In XperienCentral 10.22 and higher, the Compat library has been removed.

If the Compat library class org.apache.felix.dependencymanager.DependencyManager was present, it was used as a compatibility version for the DependencyManger 3.0.0 (non Compat). All DependencyManager object implementations in plugin Activators where the version of Compat is used will no longer work in XperienCentral versions 10.22.0 and later. In the locations where this variant is used, you must refactor to the DependencyManager 3.0.0/4.4.1 (org.apache.felix.dm.DependencyManager) (non Compat) variant. 

For project plugins the refactoring should be straightforward when upgrading to XperienCentral 10.22 or higher. For plugins that must be deployed on all XperienCentral versions (reusables), a fix is available and implemented in the reusable Utility Services (version 1.6.2).

You must refactor your plugins or reusables in the following cases:

Project Plugins 

If your Activator uses the DependencyManager object with package name org.apache.felix.dependencymanager, change this to org.apache.felix.dm and replace the createService() method with createComponent(). The Service class is no longer available. If your Activator overrides the init() method, refactor this to override the start method and retrieve the DependencyManager object from the ComponentBundleActivatorBase class.

Reusable Plugins 

The same situation applies as above, except you need to add an extra subclass in the Activator class in order to be compatible with XperienCentral versions 10.22.0 higher. If the reusable already uses the Utility Services dependency, you can use the com.gxwebmanager.solutions.wmsutilityservices.osgi.CompatibleActivatorBase in your Activator class. If not, you can add the dependency or copy the class to your own plugin, however, this is not recommended. Also add the  org.apache.felix.dm.*;version="[3.0,5.0)" import package to your pom.xml maven-bundle-plugin. This will ensure that the old 3.0.0 and new 4.4.1 DependencyManager version can be used by your reusable.

If your Activator class uses the createServiceDependency() method to add a Service to the DependencyManager (in REST cases for example), you must refactor this implementation to use the addServiceDependency() method from the CompatibleActivatorBase class in reusable Utility Services.

If your Activator class does not use a DependencyManager object and the Activator class extends from the XperienCentral ComponentBundleActivatorBase class, no refactoring is required. You may need to build your plugin against the XperienCentral 10.22 or newer version.


The required changes described above should be sufficient to make your plugins compatible with XperienCentral 10.22.0 and higher. In some cases, however, this may not be sufficient and further refactoring may be needed. Contact your GX consultant if you have any questions or are unable to get your plugins to work.


When refactoring is finished and XperienCentral has been upgraded to this version or higher, the DependencyManager Compat 3.0.0 bundle can be unstalled.

Custom Facets

Two facets for the keywords field have been added in this release. In order to be able to uniquely identify a facet, changes have been made that affect custom made facet components. The following changes must be made in your project code:

  • In the interface SearchFacetComponentDefinition, the method getIdentifier() has been added. Every class implementing this interface must therefore add this method. The identifier should be a unique string identifying the facet.
  • The constructor of the class SimpleSearchFacetComponentDefinition has been changed. It now includes a parameter for the unique identifier. The new signature is:

    SimpleSearchFacetComponentDefinition(String identifier, String widgetId, Class<?> valuesType, List<String> path, int priority, Map<Locale, String> titles, int position, Map<String, String> properties

    All references to this constructor should be changed.
  • For projects or reusables that use custom Dojo facet search code (those that extend \wmpgui\widgets\advancedsearch\facet\FacetWidget.js) there are some more API changes that you must be aware of:
    • FacetWidget now has an extra member for the facet identifier. This is accessible in widgets via the FacetWidget method called getFacetIdentifier(). Also, the constructor for it has been changed to:

      FacetWidget(fieldIdentifier, facetTitle, facetProperties, facetIdentifier)

    • If you define a FacetQuery in your custom facet widget, the constructor for this object is extended with a parameter for the facet identifier. The constructor is now:

      FacetQuery(fieldIdentifier, facetIdentifier, facetParameters, valueCountQueries, valuesFilter, valuesLimit)

    • If you define FacetDefinition objects in your custom widget code, the constructor has been changed to:

      FacetDefinition(fieldIdentifier, name, properties, facetIdentifier, FacetWidget)


It will depend on your specific use case how your code should be changed. It may be the case, for example, that your custom code uses a FacetQuery just for showing a result set without having to do any filtering. In this case, an empty string can be used for the facet identifier field in your FacetQuery constructor. In other cases where your FacetQuery is indeed bound to a certain facet, you need to use the facet identifier for that facet.

Other Changes

  • The formvalidation.js file in the wmpformpresentation plugin has been changed and needs to be updated when overruled in a custom presentation.
  • The Is Used In widget can now recognize custom media items. You do need to make some modifications to your code, however. See Custom Media Items and the Is Used In Widget.




 

XperienCentral 10.21.1

A problem has been fixed that caused deleted elements to not be completely removed which resulted in excessive space being taken up in the database. After upgrading and starting up XperienCentral for the first time, a task is executed that removes these deleted elements — in some environments, this could take some time to complete.




 

XperienCentral 10.18.0


  • After upgrading to XperienCentral 10.18, a list can only have one personalization applied to it — individual items in a list cannot be separately personalized. If a list has more than one personalization applied to it before the upgrade, the first one encountered is applied to the whole list and the others are removed. In an upgrade situation, a list personalization is applied only after the first time the content item on which it appears is edited and saved. This applies to the frontend as well. This is done in order to make personalizations work consistently.
  • Logging has been added for several authentication and other sensitive events (logging in, changing a user's persmissions, etc.). To store this logging in a separate logging file on the server, some additions must be added to the logging.properties file. Be sure to shut down the server before applying these changes.

    The first line defines the so-called logging handlers that are used. This should be extended with a new handler. The new line must be:

    handlers=1catalina.org.apache.juli.FileHandler,2localhost.org.apache.juli.FileHandler,3manager.org.apache.juli.FileHandler,4host-manager.org.apache.juli.FileHandler, 5gxsecuritylogging.org.apache.juli.FileHandler,java.util.logging.ConsoleHandler

    where 5gxsecuritylogging.org.apache.juli.FileHandler is the new handler. Do not add the handler to the line ".handlers". Note that all sensitive events are logged at the INFO level.

    Add the definition for the new handler at the bottom of the file as follows:

    5gxsecuritylogging.org.apache.juli.FileHandler.level=INFO5gxsecuritylogging.org.apache.juli.FileHandler.directory=${catalina.base}/logs 5gxsecuritylogging.org.apache.juli.FileHandler.prefix=audit.nl.gx.webmanager.services.securitylogging.level=INFO nl.gx.webmanager.services.securitylogging.handlers=5gxsecuritylogging.org.apache.juli.FileHandler

    After these changes are applied, restart the server. A clean log file is initialized in the Tomcat "logs" directory, prefixed with "audit".  For other application servers, please consult their documentation for information on how to configure a separate log file.

  • A problem has been fixed that caused added database references to be incorrectly stored in XperienCentral. The fix will only ensure that future references are correct, not existing ones. If you refer to database items within media items, you must manually remove the <webmanager-root>/work/contentindex directory after the upgrade and allow it to be regenerated (selecting contentindex_queue_empty_reindex in the Setup Tool is not sufficient).




 

XperienCentral 10.17.0


  • Apache Tomcat version 8.5.14 has been integrated. For Apache Tomcat the server.xml has changed:

    <Resource name="jdbc/WebManagerDb" auth="Container" type="javax.sql.DataSource" username="${webmanager.externaldb.dbuser}" password="${webmanager.externaldb.dbpassword}" driverClassName="${webmanager.externaldb.dbdriver}" url="${webmanager.externaldb.dburl}" maxTotal="100" maxIdle="10" maxWait="10000" testWhileIdle="true" timeBetweenEvictionRunsMillis="900000" removeAbandonedOnBorrow="false" removeAbandonedOnMaintenance="false"  removeAbandonedTimeout="30" logAbandoned="true" validationQuery="${webmanager.externaldb.validationquery}"/>
    <Resource name="jdbc/WebManagerDb" auth="Container" type="javax.sql.DataSource" username="${webmanager.externaldb.dbuser}" password="${webmanager.externaldb.dbpassword}" driverClassName="${webmanager.externaldb.dbdriver}" url="${webmanager.externaldb.dburl}" maxTotal="100" maxIdle="10" maxWait="10000" testWhileIdle="true" timeBetweenEvictionRunsMillis="900000" removeAbandonedOnBorrow="false" removeAbandonedOnMaintenance="false"  removeAbandonedTimeout="30" logAbandoned="true" validationQuery="${webmanager.externaldb.validationquery}"/>

    The way abandoned connection management should be handled by Tomcat has changed.

  • For Apache Tomcat the context.xml has changed: CookieProcessor is set to org.apache.tomcat.util.http.LegacyCookieProcessor.
  • Startup configuration for Apache Tomcat has changed: JVM configuration settings (described in settings.xml) formerly added to catalina.bat/catalina.sh are now located in setenv.bat/setenv.sh. The settings themselves are split into two categories (instead of one): catalinaopts and javaopts.
  • The manner in which horizontal page text is aligned in the Inline Editor has changed. In XperienCentral versions older than 10.17.0, the align attribute was used inside <p> tags,<h1> through <h6>, and block-quote elements. Horizontal page text is now rendered using an aligncenter or alignright parameter in a CSS horizontal text-alignment class element. The CSS of the customer website must now include these class definitions. See stylesheet.css in the webmanager-cestyle-wcb for an example.
  • The Image Element presentation imageElement.xml has three new properties: enableResize, resizeHeight and resizeWidth.




 

XperienCentral 10.16.1

Adjust presentations where the <img> tag width and height attributes are set in order to support SVG-images without explicit dimensions. See for example imageElement.jspf (line 36).




 

XperienCentral 10.16.0

  • The way page labels and media terms are indexed has changed in order to improve the label facet in Advanced Search. Before these improvements fully take effect, all pages and media items need to be re-indexed. This only affects the backend search.
  • Support for images has been added to the RSS feed presentation (rssFeedElement.jspf).




 

XperienCentral 10.15.1

The clientside SidebarContentItemWidget.contentItemChange event is now automatically triggered on content changes using contentManagement.updateContentItemVersion. Custom code using other triggers for updating the information being shown or throwing events to update other sidebar widgets should be adjusted or removed in order to avoid double updates.




 

XperienCentral 10.15.0

In order to make sure the wm-hostname tag works on WebSphere, a change in the default xslStyleSheet.jspf has been made. Also, a default hostname is included in the form.tag. If these files are overruled by a custom presentation, please update accordingly.




 

XperienCentral 10.14.0

  • Please add the file xslStyleSheetForm.xml to the presentation of your project and include it by adding the following line to xslStyleSheet.jspf, according to the example presentation:

    <wm:render presentationName="xslStyleSheetForm" />

  • In order to render Interactive Forms in a cross-domain manner, a number of files have been changed. If the default contentpartEmbedded.jspf, form.tag, formStep.jspf, or formvalidationbindings.js are overruled in a custom presentation, please synchronize these files. Also, a CORSFilter for Cross-Origin Resource Sharing has been added to the web.xml. If you are using a modified web.xml file, please update accordingly.




 

XperienCentral 10.13.0

  • Interactive Forms now supports RBAC authorization for all handlers, routers, validators, form fragments and custom extension tabs. For product components, authorization for permission groups has been set. Please review any roles not based on permission groups in order to assign the correct permissions. Custom components will be accessible to all users if no authorization is assigned. RBAC authorization can be added to custom form components in the Activator.
  • The HTML structure of lists has changed in order to comply with the HTML5 specification. Each sub-list is now nested in a list item tag <li> instead of being a direct child of a list tag <ul> or <ol>. Any CSS rules that rely on the latter structure will have to be updated in order to produce the same visual result.




 

XperienCentral 10.12.1

  • Users can now be granted rights to access XperienCentral in specific ways. Whereas a user could always use password-based login and/or container-based (if enabled), each login method now has to be enabled for each user. By default, all users will be allowed all relevant access methods. We advise you to review the list of ways that each user may log in after the upgrade and adjust them accordingly.
  • String interpolation in Interactive Forms has changed slightly. In previous versions of XperienCentral, a JavaScript syntax error would cause the original string value to be returned.  This error is now logged and other expressions (if any) will be evaluated. This may result in partially interpolated strings being returned instead of the input string.
  • When upgrading to XperienCentral 10.12.1 or newer, the index directories contentindex and searchengine are removed automatically. However, in a clustered environment, this is only done on the read/write node. To upgrade successfully, the aforementioned index directories should be removed manually from all the read-only nodes.
  • JBoss/Wildfly application server users should deactivate the "as-default" profile and activate the Maven "as-jboss" profile by uncommenting the profiles in the profiles section in the settings.xml or by passing the profiles as Maven profile using the Maven command line -P <profiles> option.




 

XperienCentral 10.12.0

  • SOLR has been upgraded to version 5.5.1, therefore it is necessary to fully rebuild the backend and frontend search indices. The former is built automatically after the upgrade. Please note that this may take some time to complete and could cause high server load. The frontend search index rebuild should be triggered manually via the Setup Tool.
  • The files conf/core0/conf/schema.xml and conf/core0/conf/solrconfig.xml have been updated. If you have made custom changes to one or both of these files, it is necessary to merge the new files with the custom ones. If no custom changes have been made, the new versions of the files can simply be used instead of the old ones.
  • The secure form signer used to protect forms against tampering has been changed. All dumped pages which contain interactive forms or advanced forms will need to be regenerated or flushed from the cache. Any old pre-upgrade forms submitted by browsers to the website after the upgrade will be rejected by the secure forms checking filter.
  • Form sessions can now be completed if a different form version becomes active. If the default showFormElementSsi.jspf, formFragmentOverview.jspf and form.tag are overruled in a custom presentation, please synchronize these files.




 

XperienCentral 10.11.0

  • An extra input field has been added to the IAF csfw fields. If a custom form.tag is used in the presentation, please add the following hidden input:

    <input type="hidden" name="csfw_requestedChannel" value="${wmfn:escapeToHtml(presentationcontext.channel)}"/>

  • The E-Cards, Poll and Who-is-Who functionalities have been removed and all their persisted content will be automatically removed during the upgrade process.
  • The system presentation JSP elementAnchor.jspf with scope ElementAnchor was changed and should be copied to/synchronized with the project specific presentation.
  • In Interactive Forms, an error on the form scope previously did not stop execution of any components in a conditional block. If your project depends on this behavior, you will have to change the relevant conditions in Interactive Forms.
  • One line of text used by the Search element is garbled when shown on a Dutch page. To correct this by hand, log into XperienCentral, navigate to the Configuration menu at the top of the page, select Language Labels and ensure that "Dutch" is selected, Open the "wm_language_search" part of the dialog and update the "all_pages" entry to "Alle categorieën".




 

XperienCentral 10.10.1

Links are now filtered by scheme. Schemes that are not allowed result in removal of the illegal link. Allowed link schemes can be configured using the Setup Tool, property valid_link_schemes in the website settings. The following schemes are accepted by default: http, https, mailto. In addition to these we accept relative URLs and anchors by default. We advise you to customize which schemes are accepted such that only the bare minimum is accepted.



 

XperienCentral 10.10.0

  • Because of security reasons it is recommended to disable the following permissions for the Main Editor role when being used: "Maintain design templates", "Maintain application servers", "Maintain application proxy servers", "Maintain application proxy servers", "Maintain application replacements", "Maintain Layouts", "Maintain XSLT expressions", "Maintain language labels", "Maintain users", "Maintain roles" and "Import users".
  • For security reasons, it is no longer permitted to use the Interactive Forms "Copy File Handler" to copy files to any arbitrary location. The only directories (and its subdirectories) to which the copy file handler is allowed to copy files are those specified in the configuration (the property "website_settings.file_upload_valid_directories" in the Setup Tool). By default, no directories are specified, which means that by default attempting to copy files will fail. When upgrading, please configure the allowed directories in the Setup Tool. It is recommended that you only use directories that are not part of GX Webmanager 10 XperienCentral itself. The new setting should also be used in custom code where files can be uploaded to a user-defined location.
  • And also the following functionalities have been removed because of security considerations: Design Templates (panel), Design Template Folders (tab).  Similar functionality is provided by the System Utilities - File Browser which should be used instead.
  • The configuration of Maintainable Folders has been moved to the Setup Tool.
  • Error messages from Spring Framework Validators are now escaped. This means HTML markup can not be used in these error message any more. Typically you need to remove styling like <font color="red"> from your message files. CSS styling is possible using the "span.error" selector.
  • Labels for the wmedit:radioButton, wmedit:select and wmedit:selectItem JSPtags will now be escaped to HTML by default. In case HTML is used in such labels, this needs to be replaced.
  • More robust HTML escaping JSP functions are introduced as a replacement for fn:escapeXml. These are wmfn:escapeToHTML for generic use in HTML and wmfn:escapeToHTMLAttribute for escaping HTML attributes. Unlike fn:escapeXml, these functions do not escape L CODE tags that are used for links and personalization tags. It is recommended that you replace all instances of fn:escapeXml in frontend presentations with these functions. In specific cases this is required for L CODE tags and personalization to work correctly.



 

XperienCentral 10.9.0

  • The GetText servlet has been deleted. If you are using a modified web.xml file then be sure to remove any references to the GetText servlet.
  • From now on the 3.0 servlet API is supported only. To enable this the dependencies to the related artifacts need to be changed in custom poms that refer to these artifacts: javax.servlet:servlet-api and javax.servlet:jsp-api.
  • The web.xml deployment descriptor header should be changed to the 3.0 format:

    <web-app xmlns="http://java.sun.com/xml/ns/javaee" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://java.sun.com/xml/ns/javaee http://java.sun.com/xml/ns/javaee/web-app_3_0.xsd"version="3.0">          
    </web-app>  
  • Maven 3.X does not support file URLs like "file:./maven-repository" in the settings.xml anymore, therefore the "localRepository" setting must be a real file path from now on and this should be updated in your custom Maven settings if needed. An absolute path is preferred for referring to the same repository (for example in subprojects) because the settings are relative to the current project directory (see https://maven.apache.org/plugin-developers/common-bugs.html#Resolving_Relative_Paths).

  • Maven 3.X discourages using expressions for the groupId, artifactId and version settings in POMs and other descriptors. These have been replaced by constant values and, as a result, the webmanager.project.groupId, webmanager.project.artifactId and webmanager.project.version settings  from the settings.xml no longer serve a purpose and thus have been removed from the settings.xml. As a result of this it may be necessary to update the values of your project specific webmanager.staticbasedir, webmanager.backendbasedir and webmanager.cleansitelocation settings.

  • Because the Maven plugin for OSGI bundles has been replaced in Maven 3.X, the following adjustments are needed in the pom.xml of custom plugins.

    PACKAGING:
        Maven 2:
          <project ...>
            <packaging>osgi-bundle</packaging>
            ...

        Replacement in Maven 3:
          <project ...>
            <packaging>bundle</packaging>
            ...

      MAVEN OSGI PLUGIN: Note especially that the <explicitImportPackage> tag is not needed any more.
      Previously this tag was used to make exported local packages available within the plugin code.

    Maven 2:
          <plugin>
            <groupId>org.apache.felix.plugins</groupId>
            <artifactId>maven-osgi-plugin</artifactId>
            <configuration>
              <osgiManifest>
                <bundleActivator>...</bundleActivator>
                <exportPackage>...</exportPackage>

                <explicitImportPackage>...</explicitImportPackage>
              </osgiManifest>
            <configuration>
            ...

        Replacement in Maven 3:
          <plugin>
            <groupId>org.apache.felix</groupId>
            <artifactId>maven-bundle-plugin</artifactId>
            <configuration>
              <instructions>
                <Bundle-Activator>...</Bundle-Activator>
                <Export-Package>...</Export-Package>

                <!-- REMOVED! explicitImportPackage -->
              </instructions>
            <configuration>
            ...  

  • If a custom parent pom.xml is used in place of the one delivered in the XperienCentral SDK ZIP (nl.gx.webmanager.wcbs:webmanager-wcbs), then you need to make the following changes in the parent pom.xml. Some of these tags can also be used directly in the pom.xml of a plugin. In that case, the same "translation" should be used there.

      Maven 2:
        <plugin>
          <groupId>org.apache.felix.plugins</groupId>
          <artifactId>maven-osgi-plugin</artifactId>
          <version>...</version>
          <configuration>
            <manifestFile>...</manifestFile>
            <osgiManifest>
              <bundleVendor>...</bundleVendor>
              <bundleSymbolicName>...</bundleSymbolicName>
              <bundleName>...</bundleName>
              <bundleDescription>...</bundleDescription>
              <bundleSource>...</bundleSource>
              <bundleDate>...</bundleDate>

              <bundleManifestVersion>${webmanager.manifestversion}</bundleManifestVersion>
            </osgiManifest>
          <configuration>
          ...

      Replacement in Maven 3:
        <plugin>
          <groupId>org.apache.felix</groupId>
          <artifactId>maven-bundle-plugin</artifactId>
          <version>2.5.3</version>
          <configuration>
            <archive>
              <manifestFile>...</manifestFile>
            </archive>
            <instructions>
              <Embed-Dependency>*;scope=compile</Embed-Dependency>  <!-- NEW! -->
              <Embed-Transitive>true</Embed-Transitive>  <!-- NEW! -->
              <Export-Package/>  <!-- NEW! -->

              <Bundle-Vendor>...</Bundle-Vendor>
              <Bundle-SymbolicName>...</Bundle-SymbolicName>
              <Bundle-Name>...</Bundle-Name>
              <Bundle-Description>...</Bundle-Description>
              <Bundle-Source>...</Bundle-Source>
              <Bundle-Date>...</Bundle-Date>

              <!-- REMOVED: bundleManifestVersion -->
            </instructions>
          <configuration>
          ...

  • The maven-bundle-plugin adds version information to the Manifest file for its dependencies. This information is checked at runtime in order to ensure that an accepted version of the referred plugin is installed on the system, otherwise the plugin will fail to start. The default runtime version requirements are sensible, but when dealing with 3rd party components you might need to overrule these default requirements. This can be done as follows to allow v1.x.x - v5.x.x:    <Import-Package>com.gxwebmanager.tests.testservice.*;version="[1,6)",*</Import-Package>.




 

XperienCentral 10.7.1

XperienCentral 10.7.1 provides an oEmbed service to embed XC content in external oEmbed consumers. The presentation of this content is provided by some XC presentation files. An example implementation can be found in the wmpcommunityeditionstyle WCB (provided in the edition-bundles directory of the release) that contains presentations with the following names:  "WM page embed", "WM page embed ssi", "WM contentpart embedded" that are used to render the oEmbed presentation. "WM content" and "WM databasepage" are invoked but not modified.



 

XperienCentral 10.7.0

  • The manner in which the active version of a form or form section is determined has been changed. It no longer makes use of a predefined set of states, but uses the XperienCentral Workflow functionality instead. As a result of this the getActiveVersion and setActiveVersion methods on the Form and FormSection class have been deprecated. The getActiveVersion method now invokes the newly introduced getCurrent method to determine which version is returned as the  "active" version. The setActiveVersion no longer executes any logic at all.
  • The behavior of the Session#getWrapper method has been altered when retrieving Content Items (instances of MediaItem). Previously this method would return an object even if none could be found for the requested identifier while now it will return null in this situation.
  • 10.7.0 introduces support for Workflow in Interactive Forms. In order for this to work properly, WebManager sets up a new Workflow Repository Model called "Interactive Forms Workflow". You may want to review whether the permissions assigned to each activity suit your needs. You can find Workflow Repository Model configuration in the "Workflow" menu. The following permissions have been introduced in WebManager 10.7.0: Copy forms, create forms, create versions of forms, delete forms and edit forms.




 

XperienCentral 10.5.0

The model in order to store personalizations has been refactored. As a result, export files created using the content export functionality in the setup tool of older XperienCentral versions containing personalizations or references to personalizations cannot be imported on XperienCentral 10.5.0 and vice versa.



 

XperienCentral 10.4.1

  • In 10.4.1 the logic which adds anchors and back to top links to elements has been moved from the content.jspf, which loops over and renders all elements, to two separate presentation JSPs, one with scope ElementAnchor, which prepends the anchors to an element if applicable and one with scope ElementBackToTop, which adds the back to top links to an element if applicable.
  •  All element related logic should be removed from your project specific presentation JSPs which currently loop over and render the elements, like the content.jspf in the webmanager-cestyle-wcb and add two new presentation JSPs based on the elementAnchor.jspf and elementBackToTop.jspf in the webmanager-cestyle-wcb.



 

XperienCentral 10.4.0


  • In 10.4.0 all default database connections are merged to one database connection named WebManagerDb which by default is accessed through JNDI lookups. Therefore it is necessary that before deploying  the application the WebManagerDb datasource is configured to be available on the application server. For Apache Tomcat edit the server.xml and add this resource to the context of the backend webapp:

    Resource name="jdbc/WebManagerDb" auth="Container" type="javax.sql.DataSource" username="${webmanager.externaldb.dbuser}" password="${webmanager.externaldb.dbpassword}"        driverClassName="${webmanager.externaldb.dbdriver}" url="${webmanager.externaldb.dburl}" maxActive="100" maxIdle="10" maxWait="10000" testWhileIdle="true"         timeBetweenEvictionRunsMillis="900000" removeAbandoned="true" removeAbandonedTimeout="30" logAbandoned="true" validationQuery="${webmanager.externaldb.validationquery}"/>>


    Note that you still have to fill in the correct values for the username, password, driverClassName, URL and validationQuery attributes. Examples of these can be found in the settings.xml.

    For Jboss edit the standalone.xml and add this datasource to datasources subsystem:


    <datasource jndi-name="java:jboss/jdbc/WebManagerDb" pool-name="WebManagerDb" enabled="true" use-java-context="true">
       <connection-url>${webmanager.externaldb.dburl}</connection-url>
          <driver>${driverName}</driver>
         <security>
             <user-name>${webmanager.externaldb.dbuser}</user-name>
             <password>${webmanager.externaldb.dbpassword}</password>
         </security>
    </datasource>


    Note that you still have to fill in the correct values for the connection-url, driver, user-name and password. Examples for the connection-url, driver and user-name can be found in the settings.xml. The driver value has to correspond with the name attribute of the driver you wish to use as defined in the drivers tag in the datasources subsystem. Furthermore, the driver for your database must be copied to the lib directory of your Tomcat or JBoss installation. Supported drivers can be found in the ext-directory in the root of the SDK distribution.

    It is advised to generate a new repository.xml using the maven configure-jcr-repository profile to make sure the jcr also accesses the database using JNDI and uses the WebManagerDb database connection. When you place this newly generated repository.xml you need to completely rebuild the JCR-index and thus stop the application server, remove the current repository directory and then start the application server again. If your installation contains custom database connections, you have to manually configure those to make use of JNDI, which includes adding the datasource to the application server configuration and updating the database connection set in the [Database configuration] tab of the setup tool.

    If you don't want to use JNDI, you have to fill in the old settings in the dbcbmanager sets in the dpcbmanager_defaults.xml which are generated in the WEB-INF folder of the webmanager-backend-webapp based on the settings.xml before executing the upgrade. You cannot generate non-JNDI dbcpmanager_defaults.xml using a maven command you always have to do this manually.

  • The secure form signer used to protect forms against tampering has been changed. All dumped pages which contain interactive forms or advanced forms will need to be regenerated or flushed from the cache. Any old pre-upgrade forms submitted by browsers to the website after the upgrade will be rejected by the secure forms checking filter.

  • PageVersionEvent.getTargetPageVersion() is deprecated; use .getPageVersion() instead. This change is relevant only for event handlers that use the deprecated method on a COPY event.

  • PageVersionEvent.getEntity() no longer returns the original page version, it now returns the target page version. The same holds for .getPageVersion(). This change is relevant only for event handlers that use one of these methods on a COPY event.

  • ElementEvent.getElement() now returns the target element, instead of the old element. This change is relevant only for event handlers that use this method on a COPY event.

  • ElementEvent.getOriginalElement() now returns the original element. This change is relevant only for handlers that use this method on a COPY event.

  • Subscription to interface scopes is possible; this might cause issues if a handler is subscribed to both Foo.class and FooParent.class.

  • The PageManagementService no longer publishes UPDATE events, WCBs that rely on such an event being published after calling either .addLeadText(PageVersion), .addRedirect(PageVersion), or.reorderElements(PageVersion, Element[]) should now publish UPDATE events themselves.

  • HistoryEvent.TOUCH is deprecated (and no longer published), please replace this with EntityEvent.UPDATE (both PRE and POST).

  • Saving page metadata no longer publishes an MediaItemVersionEvent, but a PageVersionEvent instead.

  • Apache Commons FileUpload has been updated to v1.3.1 (from 1.2.2), any implementation of FileItem now should implement both setHeaders(FileUploadHeaders) and getHeaders(). See http://commons.apache.org/proper/commons-fileupload/changes-report.html for other changes.




 

XperienCentral 10.2.x or older to 10.3.0

  • In 10.2.1 or higher the XML parser factories of JBoss are boot delegated. Therefore, bundles that use XML parsing must import involved packages from javax.xml.* of the system bundle. Bundles cannot include a jar that provides javax.xml interfaces, or a ClassCastException occurs in combination with JBoss. This situation differs from 9.20.x as javax.xml.* packages were boot delegated. This breaks modularity of these packages leading to the problem the other way around: bundles cannot provide an implementation of a javax.xml.* package.
  • In 10.3.0 or higher the hidden fields with name formid and clientsideRouting for Interactive Forms no longer have the id attributes with respective values formid and clientsiteRouting. Custom javascript code which depends on these iID attributes has to be updated.
  • In 10.3.0 or higher, the divs with id attributes starting with "info_" and "errors_" have been extended with an identifier for the form to which they belong. Custom javascript code which depends on these id attributes has to be updated.
  • In 10.3.0 or higher add the "Create versions of content items" permission explicitly to the "Create object" activity of all workflow repository models being used, in order to be able to create content versions of content repository related types.




GX WebManager 9.18.x, 9.19.x and 9.20.x to XperienCentral 10.x.x


  • The javax.servlet:servlet artifact name has been changed to javax.servlet:servlet-api. This may require changes to dependencies in WCB pom.xml files. However, most (if not all) WCBs "inherit" this setting from XperienCentral and won't require changes. Note: From 10.9.0 the 3.0 servlet API is supported, so see below for 10.9.0 related changes to  support this version of the servlet API.  
  • Create pages as a display on page for page sections and the image, download, flash and multimedia and configure these special pages at "Website configuration" -> "Special pages".
  • Choose a page part that will display page sections that do not yet have a page section label assigned and configure it as such by checking the "Show page sections without label" checkbox at "Design templates" -> "Page parts". Make sure this page part is visible on the page section display on page configured in the previous step. Also see Online Help in XperienCentral.
  • Rebuild the search index
  • Update customized wmasolrsearch configuration
  • Presentation: Update xslStyleSheet.jspf in the "website" folder of your custom presentation WCB to check for "mode=incontext" instead of "mode=preview". This is needed for Read Access to work on the backend.
  • Tweak presentations to work seamlessly with Inline Editing. For more on this, see section 3 "Preparing  presentation WCBs for use with the Inline Editor" below.
  • From GX WebManager 10.1 XperienCentral, Interactive Forms has become integral part of the platform. As a result, the Interactive Forms bundles are not upgraded automatically, and therefore, all Interactive Forms bundles with the version 2.x.y need to be stopped and uninstalled manually.


Optional Changes

  • It is suggested that you disable adds in the incontext mode of XperienCentral.
  • Remove or update maximum platform version in pom.xml. Note that as of GX WebManager 10 XperienCentral this property is no longer honored as the GX WebManager 10 XperienCentral API will remain backwards compatible with GX WebManager 9.
  • If a WCB uses dependency manager API directly it should switch to the new dependency manager 3 API
  • Updating icons for Custom Media Items may be preferred; existing icons may typically not fit that well in the new UI. Deleting them and falling back to the default may be a valid solution in many cases. New sizes are 20x20 and 180x180 with Sprite support. Icons for Elements will probably need to be updated as well.
  • Make sure empty content items have a non-zero size (in mode=incontext) in order to be able to doubleclick on it in the Inline Editor. The same goes for elements.
  • The menu has been reordered and target menu settings in WCB component definitions are now ignored. In order to place a menu item in a specific category, use PanelComponentDefinitionImpl.setMenuCategory() to set the category to one of the constants defined in PanelComponentDefinition.



GX WebManager Versions 9.18.0 and lower

When upgrading from a version older than GX WebManager 9.18.0, it is strongly advised to upgrade to GX WebManager 9.20.x before performing an upgrade to GX WebManager 10.x XperienCentral.